# This makes a blue_list array for you, that is, it makes an array of boxes that
# are not calculated. The %w part is a shorthand way of indicating that all boxes
# are actually between double quotes and comma separated.
#
# What you need to do:
#
# Copy the Ruby code that you want to create the list from via Ctrl-C. Then press F5 from
# SciTe while in this code file.
#
# The below code creates the blue_list array populated with non-calculated boxes and
# outputs that info to the SciTe output pane and also copies it to the clipboard.
# Just do a Ctrl-V in the code file you wish to insert it into.
#
# IMPORTANT: You will need to inspect the array for boxes that should not be in there,
# this will depend on your intended usage of the array.
#
# That's it! See ya! Maybe in the near future there will be a Javascript version for this.
#
require 'tk'

calcBoxArray = Array.new
calcsStr = TkClipboard.get(nil)

boxArray = calcsStr.scan(/box\d+_\d+/).uniq

calcsStr.scan(/\s*(box\d+_\d+) *=/).uniq.each do |boxAssign|
	calcBoxArray.push(boxAssign[0])
end

blueBoxArray = boxArray - calcBoxArray

#~ print "\n\n"
#~ p boxArray
#~ print "\n\n"
#~ p calcBoxArray
#~ print "\n\n"
#~ p blueBoxArray

# Make the %w{..} box list from the blueBoxArray

codeStr = ""

codeStr += "\n\nblue_list = %w{"

blueBoxArray.each do |box|
	codeStr += "#{box} "
end

codeStr = codeStr.chomp(" ") + "}\n\n"

#
# TkClipboard.set first clears the clipboard.
#
TkClipboard.set(codeStr.empty? ? '' : codeStr, nil)

print codeStr

